#!/bin/bash
echo ""
echo "Building with Intel MPI with Intel compilers"
echo "========================================"
which mpiicc
if [ $? == 1 ]; then
  echo "ERROR: MPI is not in your path."
  echo "Please load the Intel MPI and Intel compiler modules and retry."
  exit 1;
fi
objdir=impi
./setup Sedov -2d -auto  +noio -site=grover.nic.uoregon.edu -objdir=${objdir} -makefile=${objdir}
cd ${objdir}
make clean
make -j32

/bin/rm -f out.impi.txt
cp ../run.impi.sh .
./run.impi.sh | tee ../out.impi.txt
