#!/bin/bash
echo ""
echo "Building with MPC with GNU compilers"
echo "===================================="
which mpc_cc
if [ $? == 1 ]; then
  echo "ERROR: MPI is not in your path."
  echo "Please load the MPC module and retry."
  exit 1;
fi
objdir=mpc_gnu
./setup Sedov -2d -auto  +noio -site=grover.nic.uoregon.edu -objdir=${objdir} -makefile=${objdir}
cd ${objdir}
make clean
make -j32

/bin/rm -f out.mpc_gnu.txt
cp ../run.mpc.sh .
./run.mpc.sh | tee ../out.mpc_gnu.txt
