#!/bin/bash
echo ""
echo "Building with OpenMPI with GNU compilers"
echo "========================================"
which mpicxx
if [ $? == 1 ]; then
  echo "ERROR: MPI is not in your path."
  echo "Please load the OpenMPI module and retry."
  exit 1;
fi
objdir=ompi_gnu
./setup Sedov -2d -auto  +noio -site=grover.nic.uoregon.edu -objdir=${objdir} -makefile=${objdir}
cd ${objdir}
make clean
make -j32

/bin/rm -f out.ompi.txt
cp ../run.ompi.sh .
./run.ompi.sh | tee ../out.ompi.txt
