#!/usr/bin/perl -w

# Plot rates of convergence using the error.dat file
# which is generated by the crun.pl script

my $title    = "Sedov";
my $term     = "png";
my $dotterm  = ".png";
my $lw       = 2;

$status = system "octave", "rates.m";
die if ($status);
  
open PLOTFILE, ">plot_rates" or die;
print PLOTFILE "set term $term\n";
print PLOTFILE "set key top right\n";
print PLOTFILE "set key box\n";
print PLOTFILE "set output \"$title" . "_rates" . "$dotterm\"\n";
print PLOTFILE "set title \"$title: Scaled L1 Convergence\"\n";
print PLOTFILE "set xlabel \"N Blocks\"\n";
print PLOTFILE "set ylabel \"Scaled L1 Error\"\n";
print PLOTFILE "set logscale x\n";
print PLOTFILE "set logscale y\n";

print PLOTFILE "plot \"error.dat\" using 1:2 w p lw $lw lt 1 t \"Density Errors\", ";
print PLOTFILE "\"ratefit\" using 1:2 w l lw $lw lt 1 t \"Density Rate Fit\", ";
 
print PLOTFILE "\"error.dat\" using 1:3 w p lw $lw lt 2 t \"Pressure Errors\", ";
print PLOTFILE "\"ratefit\" using 1:3 w l lw $lw lt 2 t \"Pressure Rate Fit\", ";

print PLOTFILE "\"error.dat\" using 1:4 w p lw $lw lt 3 t \"Velocity Errors\", ";
print PLOTFILE "\"ratefit\" using 1:4 w l lw $lw lt 3 t \"Velocity Rate Fit\"\n";

close PLOTFILE;    
system "gnuplot", "plot_rates";
