#!/usr/bin/perl -w

# Plot the Scaled L1 error as a function of time using the
# aerror.dat file generated by the arun.pl script

my $title    = "Sedov";
my $term     = "png";
my $dotterm  = ".png";
my $lw       = 2;
  
open PLOTFILE, ">plot_terr" or die;
print PLOTFILE "set term $term\n";
print PLOTFILE "set key top right\n";
print PLOTFILE "set key box\n";
print PLOTFILE "set output \"$title" . "_terr" . "$dotterm\"\n";
print PLOTFILE "set title \"$title: Scaled L1 Error vs Time\"\n";
print PLOTFILE "set xlabel \"Time\"\n";
print PLOTFILE "set ylabel \"Scaled L1 Error\"\n";
print PLOTFILE "set logscale y\n";

print PLOTFILE "plot \"aerror.dat\" using 1:2 w l lw $lw lt 1 t \"Density\", ";
print PLOTFILE "\"aerror.dat\" using 1:3 w l lw $lw lt 2 t \"Pressure\", ";
print PLOTFILE "\"aerror.dat\" using 1:4 w l lw $lw lt 3 t \"Velocity\"\n";

close PLOTFILE;    
system "gnuplot", "plot_terr";
