!!****if* source/diagnostics/ProtonImaging/ProtonImagingMain/ProtonBeams/pi_initializeBeams
!!
!! NAME
!!
!!  pi_initializeBeams
!!
!! SYNOPSIS
!!
!!  call pi_initializeBeams ()
!!
!! DESCRIPTION
!!
!!  Initializes the beams.
!!
!! ARGUMENTS
!!
!!  none
!!
!! NOTES
!!
!!***

subroutine pi_initializeBeams ()

  use ProtonImaging_data,   ONLY : pi_beams,         &
                                   pi_notSetInteger, &
                                   pi_notSetReal,    &
                                   pi_numberOfBeams
  implicit none

  integer :: beam
!
!
!     ...Do the initialization.
!
!
  do beam = 1, pi_numberOfBeams

     pi_beams (beam) % apertureAngle             = pi_notSetReal
     pi_beams (beam) % axisUnit1X                = pi_notSetReal
     pi_beams (beam) % axisUnit1Y                = pi_notSetReal
     pi_beams (beam) % axisUnit1Z                = pi_notSetReal
     pi_beams (beam) % axisUnit2X                = pi_notSetReal
     pi_beams (beam) % axisUnit2Y                = pi_notSetReal
     pi_beams (beam) % axisUnit2Z                = pi_notSetReal
     pi_beams (beam) % detector                  = pi_notSetInteger
     pi_beams (beam) % dimensionality            = pi_notSetInteger
     pi_beams (beam) % distanceLens2Target       = pi_notSetReal
     pi_beams (beam) % gridSeed                  = pi_notSetInteger
     pi_beams (beam) % gridSeedMaximum           = pi_notSetInteger
     pi_beams (beam) % gridSeedStepping          = pi_notSetInteger
     pi_beams (beam) % noBoundaryCondition       = .false.
     pi_beams (beam) % initialProtonSpeed        = pi_notSetReal
     pi_beams (beam) % lensRadius                = pi_notSetReal
     pi_beams (beam) % lensX                     = pi_notSetReal
     pi_beams (beam) % lensY                     = pi_notSetReal
     pi_beams (beam) % lensZ                     = pi_notSetReal
     pi_beams (beam) % numberOfProtons           = pi_notSetInteger
     pi_beams (beam) % target2LensMagnification  = pi_notSetReal
     pi_beams (beam) % targetRadius              = pi_notSetReal
     pi_beams (beam) % targetX                   = pi_notSetReal
     pi_beams (beam) % targetY                   = pi_notSetReal
     pi_beams (beam) % targetZ                   = pi_notSetReal

  end do
!
!
!     ...Ready!
!
!
  return
end subroutine pi_initializeBeams
