!!****if* source/diagnostics/ProtonImaging/ProtonImagingMain/ProtonDetection/pi_initializeDetectors
!!
!! NAME
!!
!!  pi_initializeDetectors
!!
!! SYNOPSIS
!!
!!  call pi_initializeDetectors ()
!!
!! DESCRIPTION
!!
!!  Initializes the detectors.
!!
!! ARGUMENTS
!!
!!  none
!!
!! NOTES
!!
!!***

subroutine pi_initializeDetectors ()

  use ProtonImaging_data,   ONLY : pi_detectors,        &
                                   pi_notSetInteger,    &
                                   pi_notSetReal,       &
                                   pi_numberOfDetectors
  implicit none

  integer :: detector
!
!
!     ...Do the initialization.
!
!
  do detector = 1, pi_numberOfDetectors

     pi_detectors (detector) % alignWRTbeamNr            = pi_notSetInteger
     pi_detectors (detector) % axisXunitX                = pi_notSetReal
     pi_detectors (detector) % axisXunitY                = pi_notSetReal
     pi_detectors (detector) % axisXunitZ                = pi_notSetReal
     pi_detectors (detector) % axisYunitX                = pi_notSetReal
     pi_detectors (detector) % axisYunitY                = pi_notSetReal
     pi_detectors (detector) % axisYunitZ                = pi_notSetReal
     pi_detectors (detector) % centerX                   = pi_notSetReal
     pi_detectors (detector) % centerY                   = pi_notSetReal
     pi_detectors (detector) % centerZ                   = pi_notSetReal
     pi_detectors (detector) % distance2beamLens         = pi_notSetReal
     pi_detectors (detector) % normalX                   = pi_notSetReal
     pi_detectors (detector) % normalY                   = pi_notSetReal
     pi_detectors (detector) % normalZ                   = pi_notSetReal
     pi_detectors (detector) % sideLength                = pi_notSetReal
     pi_detectors (detector) % sideTiltingAngle          = pi_notSetReal
     pi_detectors (detector) % sideTiltingAxis           = ' '

  end do
!
!
!     ...Ready!
!
!
  return
end subroutine pi_initializeDetectors
