!!****if* source/diagnostics/ProtonImaging/localAPI/pi_write2DetectorFile
!!
!! NAME
!!
!!  pi_write2DetectorFile
!!
!! SYNOPSIS
!!
!!  call pi_write2DetectorFile (integer, intent (in) :: detector,
!!                              integer, intent (in) :: bucketCount,
!!                              real,    intent (in) :: bucket (:,:))
!!
!! DESCRIPTION
!!
!!  Writes a bucket of screen protons to the appropriate detector file on disk. The file is
!!  already open and the screen protons data is appended. Only the master processor writes
!!  out the bucket.
!!
!! ARGUMENTS
!!
!!  detector      : The detector number
!!  bucketCount   : Number of elements in bucket (currently number of screen [x,y] pairs)
!!  bucket        : The bucket containing all the elements.
!!
!!***

subroutine pi_write2DetectorFile (detector, bucketCount, bucket)

  implicit none

  integer, intent (in) :: detector
  integer, intent (in) :: bucketCount
  real,    intent (in) :: bucket (1:2,1:bucketCount)

  return
end subroutine pi_write2DetectorFile
